var user = require('./user.js');
var handler = require('./event_handler').getHandler();
var io;
var boot = function(config) {
  io = require('socket.io').listen(config.port);
  io.configure('development', function(){
	  io.set('log level', 0);

    io.set('authorization', function(data, accept) {
      if (data.headers) {
            data.authorized = false;
            return accept(null, true);
      } else {
        return accept('No cookie transmitted', false);
      }
    });
  });

	io.sockets.on('connection', function(socket) {
      console.log("client connected"); 
      socket.on('disconnect', function() {
        if(socket.authorized){
          console.log(socket.user.name, 'Disconnected');
        }else{
          console.log('unauthorized socket disconnected');
        } 
      });
      socket.on('auth', function(data){
        console.log(data);
          user.decryptSocketKey(data.socketKey, function(user){
            if(user){ 
              console.log('decrypted key, user:');
              console.log(user);
              socket.user = user.user;
              console.log('authenticated');
              socket.authorized = true;
              socket.emit('authsuccess', {status: 'ok'});
              socket.join('gateway_' + socket.user._id);
            }
            else{
              console.log('bad data failing auth');
              socket.emit('authfailure');
              //socket.disconnect();
            }
          });
      });

	});
  handler.on('action::new', function(evt){
    console.log(evt);
    if(evt.act){
      console.log("doing action from the bus");
      if(io.sockets.manager.rooms['/gateway_' +evt.act.user]){
      console.log('connected gateway for sensor emitting event to gateway');
      io.sockets.in('gateway_' + evt.act.user).emit('action', evt.act);
      }else{
      console.log('queuing action ');
      }
    }
     handler.emit('action::complete', evt);
  });

}
var stop = function(){
  io.server.close();
}
module.exports.stop = stop;
module.exports.boot = boot;
